# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define bootstrap 1

%define section         free

Name:           servicemix3
Version:        3.3.2
Release:        2%{?dist}
Epoch:          0
Summary:        Apache ServiceMix ESB
License:        Apache Software License 2.0
Group:          Development/Libraries/Java
Url:            http://servicemix.apache.org/
Source0:        http://www.apache.org/dist//servicemix/servicemix-3/3.3.2/apache-servicemix-3.3.2-src.tar.gz

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        servicemix-pom.xml
# get it from http://svn.apache.org/repos/asf/servicemix/servicemix-pom/tags/servicemix-pom-4/pom.xml

Patch1:         servicemix3-nogeronimo.patch
Patch2:         servicemix3-parent-pom.patch
Patch3:         servicemix3-woden-WSDL2Processor.patch
Patch4:         servicemix3-xalan.patch
Patch5:         servicemix3-components-pom.patch
Patch6:         servicemix3-components-FTPClientPool.patch
Patch9:         servicemix3-distributions-apache-servicemix-pom.patch
Patch99:        servicemix3-bootstrap.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7
BuildRequires:  apache-commons-parent >= 0:12
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-checkstyle
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  activemq5-core
BuildRequires:  activemq5-pool
BuildRequires:  activemq5-ra
BuildRequires:  activesoap
BuildRequires:  antlr
#BuildRequires:  apache-camel
BuildRequires:  apache-commons-beanutils
BuildRequires:  apache-commons-collections
BuildRequires:  apache-commons-dbcp
BuildRequires:  apache-commons-discovery
BuildRequires:  apache-commons-fileupload
BuildRequires:  apache-commons-httpclient
BuildRequires:  apache-commons-io
BuildRequires:  apache-commons-lang
BuildRequires:  apache-commons-logging
BuildRequires:  apache-commons-net
BuildRequires:  apache-commons-pool
BuildRequires:  apache-commons-vfs
#BuildRequires:  apache-cxf20
BuildRequires:  apache-jar-resource-bundle
BuildRequires:  axis
BuildRequires:  axis2
BuildRequires:  derby
BuildRequires:  easymock2
BuildRequires:  ejb_2_1_api
BuildRequires:  geronimo-genesis2
BuildRequires:  glassfish-jstl
BuildRequires:  groovy16
BuildRequires:  howl-logger
BuildRequires:  hsqldb
BuildRequires:  j2ee_connector_1_5_api
BuildRequires:  j2ee_management_1_0_api
BuildRequires:  jacc_1_0_api
BuildRequires:  jaf_1_0_2_api
BuildRequires:  jaf_1_1_api
BuildRequires:  jakarta-taglibs-standard
BuildRequires:  janino
BuildRequires:  javamail_1_3_1_api
BuildRequires:  javamail_1_4_api
BuildRequires:  jaxen
BuildRequires:  jaxrpc_1_1_api
BuildRequires:  jaxws_2_1_api
BuildRequires:  jencks
BuildRequires:  jetty6
BuildRequires:  jetty6-maven2-plugins
BuildRequires:  jms_1_1_api
BuildRequires:  jsr223-scripting-engines-groovy
BuildRequires:  jta_1_0_1B_api
BuildRequires:  junit
BuildRequires:  lingo
BuildRequires:  livetribe-jsr223
BuildRequires:  log4j
BuildRequires:  lucene1
BuildRequires:  mojo-maven2-plugin-exec
BuildRequires:  portals-pluto10
BuildRequires:  quartz
BuildRequires:  rome
BuildRequires:  saaj_1_1_api
BuildRequires:  servicemix-build-maven-plugin
#BuildRequires:  servicemix-jbi-maven-plugin
#BuildRequires:  servicemix-res-maven-plugin
BuildRequires:  servicemix-specs
BuildRequires:  servicemix-utils
#BuildRequires:  servicemix-xfire-maven-plugin
BuildRequires:  servlet_2_4_api
BuildRequires:  servlet_2_5_api
BuildRequires:  sitemesh
BuildRequires:  slf4j
BuildRequires:  smack
BuildRequires:  smack2
BuildRequires:  spring2-all
BuildRequires:  spring2-aop
BuildRequires:  spring2-context-support
BuildRequires:  spring2-jms
BuildRequires:  spring2-tx
BuildRequires:  spring2-web
BuildRequires:  spring2-webmvc
BuildRequires:  stax_1_0_api
BuildRequires:  tranql-connector-generic
BuildRequires:  ws-woden
BuildRequires:  ws-wsif
BuildRequires:  ws_metadata_2_0_api
BuildRequires:  wsdl4j
BuildRequires:  wstx
BuildRequires:  xalan-j2
BuildRequires:  xbean
BuildRequires:  xerces-j2
BuildRequires:  xfire-aegis
BuildRequires:  xfire-core
BuildRequires:  xfire-spring
BuildRequires:  xfire-xmlbeans
BuildRequires:  xstream

BuildRequires:  drools2
#BuildRequires:  servicemix-common
#BuildRequires:  servicemix-components
#BuildRequires:  servicemix-shared

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:       java >= 0:1.6.0
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description
Apache ServiceMix is an open source ESB (Enterprise Service
Bus) that combines the functionality of a Service Oriented 
Architecture (SOA) and an Event Driven Architecture (EDA)
to create an agile, enterprise ESB.
Apache ServiceMix is an open source distributed ESB built 
from the ground up on the  Java Business Integration (JBI) 
specification JSR 208 and released under the Apache license.
The goal of JBI is to allow components and services to be
integrated in a vendor independent way, allowing users and
vendors to plug and play.

%package common
Summary:        Common module for %{name}
Group:          Development/Libraries/Java
Requires:        %{name} = %{epoch}:%{version}-%{release}

%description common
%{summary}.

%package core
Summary:        Core module for %{name}
Group:          Development/Libraries/Java
Requires:        %{name} = %{epoch}:%{version}-%{release}

%description core
%{summary}.

%package console
Summary:        Console webapps for %{name}
Group:          Development/Libraries/Java
Requires:        %{name} = %{epoch}:%{version}-%{release}

%description console
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n apache-servicemix-%{version}
%patch1 -b .nogeronimo
%patch2 -b .nocheckstyle_pmd
%patch3 -b .woden1.0M8
%patch4 -b .xalan-serializer
%patch5 -b .sav5
%patch6 -b .sav6
%patch9 -b .sav9
%if %{bootstrap}
%patch99 -b .bootstrap
%endif

cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP


%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/servicemix/servicemix-pom/4/
cp %{SOURCE3} ${MAVEN_REPO_LOCAL}/org/apache/servicemix/servicemix-pom/4/servicemix-pom-4.pom
#
export MAVEN_OPTS="-Dmaven.test.failure.ignore=true -Dmaven2.jpp.mode=true -Dmaven2.jpp.depmap.file=%{SOURCE2} -Dmaven.repo.local=${MAVEN_REPO_LOCAL}"
#export MAVEN_OPTS="${M_OPTS} -Dmaven.test.skip=true"
export MAVEN_SETTINGS=$(pwd)/settings.xml
cd src
%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven.test.skip=true \
        install

%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 src/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.apache.servicemix servicemix %{version} JPP %{name}

install -m 644 src/parent/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-parent.pom
%add_to_maven_depmap org.apache.servicemix parent %{version} JPP %{name}-parent

install -m 644 src/common/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-common.pom
%add_to_maven_depmap org.apache.servicemix common %{version} JPP %{name}-common

install -m 644 src/common/servicemix-components/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-components.pom
%add_to_maven_depmap org.apache.servicemix servicemix-components %{version} JPP/%{name} components
install -m 644 src/common/servicemix-components/target/servicemix-components-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/components-%{version}.jar

install -m 644 src/core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-core.pom
%add_to_maven_depmap org.apache.servicemix core %{version} JPP %{name}-core

install -m 644 src/core/servicemix-audit/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-audit.pom
%add_to_maven_depmap org.apache.servicemix servicemix-audit %{version} JPP/%{name} audit
install -m 644 src/core/servicemix-audit/target/servicemix-audit-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/audit-%{version}.jar

install -m 644 src/core/servicemix-core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-core.pom
%add_to_maven_depmap org.apache.servicemix servicemix-core %{version} JPP/%{name} core
install -m 644 src/core/servicemix-core/target/servicemix-core-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 src/web/servicemix-console/target/servicemix-console-%{version}.war \
               $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 src/web/servicemix-web-console/target/servicemix-web-console-3.3.2.war \
               $RPM_BUILD_ROOT%{_datadir}/%{name}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr src/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rm -rf src/target/site/apidocs
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p src/LICENSE $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr src/target/site $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root)
%dir %{_datadir}/%{name}
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%dir %{_javadir}/%{name}
%doc %{_docdir}/%{name}-%{version}
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*.jar.*
%endif

%files common
%defattr(-,root,root)
%{_javadir}/%{name}/components*.jar

%files core
%defattr(-,root,root)
%{_javadir}/%{name}/core*.jar
%{_javadir}/%{name}/audit*.jar

%files console
%defattr(-,root,root)
%{_datadir}/%{name}/*.war

%files javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/*

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/site

%changelog
* Sat Jul 09 2011 Ralph Apel <r.apel@r-apel.de> - 0:3.3.2-2
- Subpackages must R main pkg

* Fri Jul 08 2011 Ralph Apel <r.apel@r-apel.de> - 0:3.3.2-1
- 3.3.2 in bootstrap mode

